#pragma once
#include "util/i_scheduled_executor.h"
#include <thread>
#include <chrono>
#include <functional>
#include <condition_variable>
#include <iostream>
#include <mutex>



namespace spin
{
    class ScheduledExecutor : public IScheduledExecutor
    {
    public:
        ScheduledExecutor();
        ~ScheduledExecutor();

        void schedule(const std::function<void()> task, const std::chrono::milliseconds &initialDelay, const std::chrono::milliseconds &period) override;
        void stop() override;

    private:

        void worker();
        std::thread executorThread_;
        std::function<void()> task_;
        std::chrono::milliseconds period_;
        std::chrono::milliseconds initialDelay_;

        bool isStopRequested_{false};
        std::mutex mutex;
        std::condition_variable cv;
    };

} // namespace spin
